{$I PFDEFINE.INC}
{***************************************************************}
{*                       PFKTEST.PAS                           *}
{*                                                             *}
{*                   Gordon M. Cressman                        *}
{*               Research Triangle Institute                   *}
{*                                                             *}
{*                   CompuServe 75410,2451                     *}
{*               Internet gmc%titan@rti.rti.org                *}
{*                                                             *}
{*                        11-06-1989                           *}
{*                                                             *}
{* This source code is hereby released into the Public domain  *}
{* by the author.                                              *}
{***************************************************************}
program TestFKey;

uses
  TPCrt,
  TPWindow,
  TPMouse,
  PFKeys;

const
  {Colors}
  WindowAttr = $70;
  FrameAttr  = $70;
  HeaderAttr = $70;
  EntryAttr  = $0F;

  {IBM PC keyboard scan codes for special keys}
  F1  = $3B00;
  F2  = $3C00;
  F3  = $3D00;
  F4  = $3E00;
  F5  = $3F00;
  F6  = $4000;
  F7  = $4100;
  F8  = $4200;
  F9  = $4300;
  F10 = $4400;
  AF1 = $6800; {Alt+F1}

  {ASCII values}
  Enter = #13;
  ESC   = #27;

  QueryFKeys : FKeyInfoRecd = (
    FKNum   : 0;
    FKLabel : ('', 'F2-Yes', 'F3-No', '', '', 'F10-Quit');
    FKey    : (F1, F2, F3, F4, F5, F10));

  Question = 'Do you walk to work or take your lunch?';

var
  Answer : Boolean;


  {$F+}
  function GetKey : Word;
    {-A standard Turbo Professional pattern keyboard handler}
  begin
    {$IFDEF UseMouse}
    while not(KeyPressed or MousePressed) do begin
      {$ELSE}
    while not KeyPressed do begin
    {$ENDIF}
      {make sure TSR's can pop up}
      inline($CD / $28);
    end;

    {$IFDEF UseMouse}
    if KeyPressed then
      GetKey := ReadKeyWord
    else
      if MousePressed then
        GetKey := MouseKeyWord;
    {$ELSE}
      GetKey := ReadKeyWord
    {$ENDIF}
  end; {GetKey}
  {$F-}

  function Query(QuerySt : String; Default : Boolean; 
                 HelpIndex : Word) : Boolean;
    {-Asks the user a Yes/No question and returns the answer}
  type
    AnsSt = String[3];
  const
    AnswerSt : array[Boolean] of AnsSt = ('No ', 'Yes');
  var
    QueryWin : WindowPtr;
    QueryStLen : Byte absolute QuerySt;
    WinWidth, XLow,  YLow, XHigh, YHigh : Word; 
    Answer, Done : Boolean;

    ChWord : Word;
    Ch     : Char absolute ChWord;

  begin
    {$IFDEF UseMouse}
    HideMouse;
    {$ENDIF}
    PushFKeys(@QueryFKeys);

    Answer := Default;
    {Calculate window width and center in current screen width}
    WinWidth := QueryStLen + 10;
    XLow := (ScreenWidth - WinWidth) div 2 + 1;
    XHigh := XLow + WinWidth - 1;
    {Center window 5 rows high in current screen height}
    YLow := (ScreenHeight - 5) div 2;
    YHigh := YLow + 4;

    if not MakeWindow(QueryWin, XLow, YLow, XHigh, YHigh, True, False, False,
                      WindowAttr, FrameAttr, HeaderAttr, '') then Halt(203);
    if not DisplayWindow(QueryWin) then Halt(203);

    FastWriteWindow(QuerySt, 2, 3, HeaderAttr);
    GotoXY(QueryStLen + 4, 2);
    NormalCursor;

    {$IFDEF UseMouse}
    ShowMouse;
    {$ENDIF}

    {Dispose of pending keyboard and mouse keypresses}
    while KeyPressed do
      ChWord := ReadKeyWord;
    {$IFDEF UseMouse}
    while MousePressed do
      ChWord := MouseKeyWord;
    {$ENDIF}

    Done := False;
    repeat
      {$IFDEF UseMouse}
      HideMouse;
      {$ENDIF}
      FastWriteWindow(AnswerSt[Answer], 2, QueryStLen + 4, EntryAttr);
      {$IFDEF UseMouse}
      ShowMouse;
      {$ENDIF}

      {$IFDEF EnableMouseHotBoxes}
      MouseHotBox(XLow, YLow, XHigh, YHigh, LeftButton, $0020);
      {$ENDIF}

      ChWord := GetKey;

      {$IFDEF EnableMouseHotBoxes}
      PopMouseHotBox;
      {$ENDIF}

      Ch := Upcase(Ch);
      case ChWord of
        F2 : Answer := True;
        F3 : Answer := False;

        {$IFDEF UseMouse}
        MouseRt,
        {$ENDIF}
        F10 : Done := True;

        else
          case Ch of
            'Y'    : Answer := True;
            'N'    : Answer := False;
            ' '    : Answer := not Answer;
            Enter,
            ESC    : Done := True;
          end; {case Ch}
      end; {case ChWord}
    until Done;

    {$IFDEF UseMouse}
    HideMouse;
    {$ENDIF}
    DisposeWindow(EraseTopWindow);
    PopFKeys;
    Query := Answer;
  end; {Query}


begin {TestFKey}
  {$IFDEF UseMouse}
  EnableEventHandling;
  {$ENDIF}

  ClrScr;
  Answer := Query(Question, False, 0);
  ClrScr;

  if Answer then
    WriteLn('You answered "Yes"')
  else WriteLn('You answered "No"');
end. {TestFKey}
